{
//**************Alexander Rodigin********************
//********************RUSSIA*************************
//*****************ras@ras.udm.ru********************
}
unit UserComp;

interface

uses
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls,
  Forms, Dialogs, Registry;

type
  TOSVersion=record
               Major : integer;
               Minor : integer;
               BuildNumber : integer;
               PlatformId  : integer;
             end;

type
  TUserComp = class(TComponent)
  private
    { Private declarations }
    FOSVersion :TOSVersion;
    FWinDir    :string;
    FWinSysDir :string;
    FCompany   :string;
    FUserName  :string;
    FLogin     :string;
    FSendTo    :string;
    FRecent    :string;
    FDesktop   :string;
    FFavorites :string;
    FPrograms  :string;
    FStartMenu :string;
    FStartup   :string;
    FFonts     :string;
    FPersonal  :string;
    FNetHood   :string;
    FPrintHood :string;
    FTemplates :string;
    FAppData   :string;
    FCache     :string;
    FCookies   :string;
    FHistory   :string;
  protected
    { Protected declarations }
    procedure Loaded;override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    property OSVersion :TOSVersion read FOSVersion;
    property Company   :string read FCompany;
    property UserName  :string read FUserName ;
    property Login     :string read FLogin ;
    property WinDir    :string read FWinDir ;
    property WinSysDir :string read FWinSysDir ;
    property SendTo    :string read FSendTo ;
    property Recent    :string read FRecent ;
    property Desktop   :string read FDesktop ;
    property Favorites :string read FFavorites ;
    property Programs  :string read FPrograms ;
    property StartMenu :string read FStartMenu ;
    property Startup   :string read FStartup ;
    property Fonts     :string read FFonts ;
    property Personal  :string read FPersonal ;
    property NetHood   :string read FNetHood ;
    property PrintHood :string read FPrintHood ;
    property Templates :string read FTemplates ;
    property AppData   :string read FAppData ;
    property Cache     :string read FCache ;
    property Cookies   :string read FCookies ;
    property History   :string read FHistory ;
  published
    { Published declarations }

  end;
//////////////////////////////
procedure Register;

implementation
//////////////////////////////
procedure TUserComp.Loaded;
var
  reg:TRegIniFile;
  buf:array[1..255]of char;
  nSize:Cardinal;
  OSInfo:_OsVersionInfoA;
begin
  inherited;
  reg := TRegIniFile.Create('');
  reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Explorer\',False);
  with reg do begin
    FSendTo    :=ReadString('Shell Folders','SendTo','');
    FRecent    :=ReadString('Shell Folders','Recent','');
    FDesktop   :=ReadString('Shell Folders','Desktop','');
    FFavorites :=ReadString('Shell Folders','Favorites','') ;
    FPrograms  :=ReadString('Shell Folders','Programs','');
    FStartMenu :=ReadString('Shell Folders','Start Menu','');
    FStartup   :=ReadString('Shell Folders','Startup','');
    FFonts     :=ReadString('Shell Folders','Fonts','');
    FPersonal  :=ReadString('Shell Folders','Personal','');
    FNetHood   :=ReadString('Shell Folders','NetHood','') ;
    FPrintHood :=ReadString('Shell Folders','PrintHood','');
    FTemplates :=ReadString('Shell Folders','Templates','') ;
    FAppData   :=ReadString('Shell Folders','AppData','');
    FCache     :=ReadString('Shell Folders','Cache','') ;
    FCookies   :=ReadString('Shell Folders','Cookies','');
    FHistory   :=ReadString('Shell Folders','History','');
  end;
  reg.CloseKey;
  reg.OpenKey('Software\Microsoft\MS Setup (ACME)\',False);
  with reg do begin
    FCompany :=ReadString('USER INFO','DefCompany','');
    FUserName:=ReadString('USER INFO','DefName','');
  end;
  reg.CloseKey;
  reg.Free;
  GetWindowsDirectoryA(@buf,SizeOf(buf));
  FWinDir:=buf;
  GetSystemDirectoryA(@buf,SizeOf(buf));
  FWinSysDir:=buf;
  buf[1]:=#0;
  nSize:=SizeOf(buf);
  GetUserName(@buf,nSize);
  FLogin:=buf;

  OSInfo.dwOSVersionInfoSize:=SizeOf(OSInfo);
  GetVersionEx(OSInfo);
  with FOSVersion do begin
    Major:=OSInfo.dwMajorVersion;
    Minor:=OSInfo.dwMinorVersion;
    BuildNumber:=OsInfo.dwBuildNumber;
    PlatformId:=OSInfo.dwPlatformId;
  end;
end; { procedure TUserComp.Loaded }
//////////////////////////////
constructor TUserComp.Create;
var
  Already:Byte;
  i:Integer;
begin
  inherited;
  Already:=0;
  if (csDesigning in ComponentState) then
    if (AOwner is TForm) then
      with (AOwner as TForm) do
      begin
        for i := 0 to ComponentCount - 1 do
          if Components[i] is TUserComp then Inc(Already);
        if Already>1 then raise Exception.Create('You can''t create a second TUserComp on the same form!');
      end
    else
      raise Exception.Create('You can create a TUserComp only on the form!');
end; { }
//////////////////////////////
procedure Register;
begin
  RegisterComponents('RAS', [TUserComp]);
end;

end.
 